/**
*/
import org.omg.CORBA.*;

import RTIcap.*;
import owrti.util.CDRCoderEncoder;

/**
*
* This is callback object to receive RTI messages.
* We used the following callback messages for this demo program:
*
* <p>
* <ol>
* <p> <li> timeAdcanceGrant
* <p> <li> timeRegulationEnabled
* <p> <li> timeConstrainedEnabled
* <p> <li> receiveInteractionWithTime
* <p> <li> receiveInteraction
* </ol>
*
* <p>
* @date May 11, 1998 ( Updated May 11, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class ChatFedAmb extends RTIcap._FederateAmbassadorImplBase {

    ChatGUI  boss;

    public ChatFedAmb(ChatGUI father) {  boss = father; }

    public void 
    synchronizationPointRegistrationSucceeded(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    synchronizationPointRegistrationFailed(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    announceSynchronizationPoint(String theLabel, String theTag)
        throws RTIcap.FederateInternalError
    { }

    public void 
    federationSynchronized(String theLabel) throws RTIcap.FederateInternalError
    { }

    public void 
    initiateFederateSave(String theLabel)
        throws RTIcap.UnableToPerformSave, RTIcap.FederateInternalError
    { }

    public void federationSaved() throws RTIcap.FederateInternalError { }

    public void federationNotSaved() throws RTIcap.FederateInternalError { }

    public void 
    requestFederationRestoreSucceeded(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void 
    requestFederationRestoreFailed(String theLabel)
        throws RTIcap.FederateInternalError
    { }

    public void federationRestoreBegun() throws RTIcap.FederateInternalError { }

    public void 
    initiateFederateRestore(String theLabel, short handle)
        throws RTIcap.SpecifiedLabelDoesNotExist, RTIcap.CouldNotRestore, 
               RTIcap.FederateInternalError
    { }

    public void federationRestored() throws RTIcap.FederateInternalError { }

    public void federationNotRestored() throws RTIcap.FederateInternalError { }

    public void 
    startRegistrationForObjectClass(short theClass)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    stopRegistrationForObjectClass(short theClass)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    turnInteractionsOn(short theHandle)
        throws RTIcap.InteractionClassNotPublished, RTIcap.FederateInternalError
    { }

    public void 
    turnInteractionsOff(short theHandle)
       throws RTIcap.InteractionClassNotPublished, RTIcap.FederateInternalError
    { }

    public void 
    startUpdates(short theClass, short[] theAttributes)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    stopUpdates(short theClass, short[] theAttributes)
        throws RTIcap.ObjectClassNotPublished, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    discoverObjectInstance(int theObject, short theObjectClass)
        throws RTIcap.CouldNotDiscover, RTIcap.ObjectClassNotKnown, 
               RTIcap.InvalidFederationTime, RTIcap.FederateInternalError
    { }// end of discoverObjectInstance()

    public void 
    reflectAttributeValuesWithTime(int theObject, 
               RTIcap.AttributeHandleValuePair[] theAttributes, double theTime, 
               String theTag, RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateOwnsAttributes, RTIcap.InvalidFederationTime, 
               RTIcap.FederateInternalError
    { }// end of reflectAttributeValuesWithTime()

    public void 
    reflectAttributeValues(int theObject, 
               RTIcap.AttributeHandleValuePair[] theAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateOwnsAttributes, RTIcap.FederateInternalError
    { }// end of reflectAttributeValues()

    /** */
    public void 
    receiveInteractionWithTime(short theInteraction, 
               RTIcap.ParameterHandleValuePair[] theParameters, double theTime, 
               String theTag, RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.InteractionClassNotKnown, 
               RTIcap.InteractionParameterNotKnown, 
               RTIcap.InvalidFederationTime, RTIcap.FederateInternalError
    {
       if( theInteraction==boss.getChatterRTITypeId() ) {
          for(int i=0;i<theParameters.length;i++)
            if( theParameters[i].handle == boss.getChatterRTIMsgTypeId() )
                boss.addMessage(theParameters[i].value);
       }// end of if
    }// end of receiveInteractionWithTime()

    /** */
    public void 
    receiveInteraction(short theInteraction, 
               RTIcap.ParameterHandleValuePair[] theParameters, String theTag)
        throws RTIcap.InteractionClassNotKnown, 
               RTIcap.InteractionParameterNotKnown, RTIcap.FederateInternalError
    { //  look for the known interaction class and parameter
      if( theInteraction==boss.getChatterRTITypeId() ) {
          for(int i=0;i<theParameters.length;i++)
            if( theParameters[i].handle == boss.getChatterRTIMsgTypeId() )
                boss.addMessage(theParameters[i].value);
       }// end of if
    }// end of receiveInteraction()

    public void 
    removeObjectInstanceWithTime(int theObject, double theTime, String theTag, 
               RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.InvalidFederationTime, 
               RTIcap.FederateInternalError
    { 
    }// end of removeObjectInstanceWithTime()

    public void 
    removeObjectInstance(int theObject, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.FederateInternalError
    { 
    }// end of removeObjectInstanceWithTime()

    public void 
    attributesInScope(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributesOutOfScope(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    provideAttributeValueUpdate(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, RTIcap.FederateInternalError
    { }// end of provideAttributeValueUpdate()

    public void 
    turnUpdatesOnForObjectInstance(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotOwned, 
               RTIcap.FederateInternalError
    { 
    }// end of turnUpdatesOnForObjectInstance()

    public void 
    turnUpdatesOffForObjectInstance(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotOwned, 
               RTIcap.FederateInternalError
    { 
    }// end of turnUpdatesOffForObjectInstance()

    public void 
    requestAttributeOwnershipAssumption(int theObject, 
               short[] offeredAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeOwnershipDivestitureNotification(int theObject, 
               short[] releasedAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, 
               RTIcap.AttributeDivestitureWasNotRequested, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeOwnershipAcquisitionNotification(int theObject, 
               short[] securedAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAcquisitionWasNotRequested, 
               RTIcap.AttributeAlreadyOwned, RTIcap.AttributeNotPublished, 
               RTIcap.FederateInternalError
    { }

    public void 
     attributeOwnershipUnavailable(int theObject, short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, 
               RTIcap.AttributeAcquisitionWasNotRequested, 
               RTIcap.FederateInternalError
    { }

    public void 
    requestAttributeOwnershipRelease(int theObject, 
               short[] candidateAttributes, String theTag)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeNotOwned, RTIcap.FederateInternalError
    { }

    public void 
    confirmAttributeOwnershipAcquisitionCancellation(int theObject, 
               short[] theAttributes)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.AttributeAlreadyOwned, 
               RTIcap.AttributeAcquisitionWasNotCancelled, 
               RTIcap.FederateInternalError
    { }

    public void 
    informAttributeOwnership(int theObject, short theAttribute, short theOwner)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeIsNotOwned(int theObject, short theAttribute)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    public void 
    attributeIsOwnedByRTI(int theObject, short theAttribute)
        throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotKnown, 
               RTIcap.FederateInternalError
    { }

    /**
    * Change the HelloWorld federation's time. And inform that time is
    * advanced.
    */
    public void 
    timeAdvanceGrant(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.TimeAdvanceWasNotInProgress, 
               RTIcap.FederateInternalError
    { 
        boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();

    }// end of timeAdvanceGrant()

    /**
    * Change the HelloWorld federate's time. And inform that time is
    * advanced.
    */
    public void 
    timeRegulationEnabled(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.EnableTimeRegulationWasNotPending, 
               RTIcap.FederateInternalError
    { 
        boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();

    }// end of timeRegulationEnabled()

    /**
    * Change the HelloWorld federate's time. And inform that time is
    * advanced.
    */
    public void 
    timeConstrainedEnabled(double theTime)
        throws RTIcap.InvalidFederationTime, 
               RTIcap.EnableTimeConstrainedWasNotPending, 
               RTIcap.FederateInternalError
    { 
        boss.setCurrentTime( theTime );
        boss.setTimeAdvanceGranted();

    }// end of timeConstrainedEnabled()

    public void 
    requestRetraction(RTIcap.EventRetractionHandle theHandle)
        throws RTIcap.EventNotKnown, RTIcap.FederateInternalError
    { }

    public void 
    changeThresholds(RTIcap.Region theRegion, 
                     RTIcap.ThresholdSetHolder theThresholds)
        throws RTIcap.RegionNotKnown, RTIcap.FederateInternalError
    { }

}// end of ChatFedAmb
